
-----------------------------------------------------------------------
--                       Ada for Automation                          --
--                                                                   --
--                 Copyright (C) 2012, Stephane LOS                  --
--                                                                   --
-- This library is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public               --
-- License as published by the Free Software Foundation; either      --
-- version 2 of the License, or (at your option) any later version.  --
--                                                                   --
-- This library is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of    --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU --
-- General Public License for more details.                          --
--                                                                   --
-- You should have received a copy of the GNU General Public         --
-- License along with this library; if not, write to the             --
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,      --
-- Boston, MA 02111-1307, USA.                                       --
--                                                                   --
-- As a special exception, if other files instantiate generics from  --
-- this unit, or you link this unit with other files to produce an   --
-- executable, this  unit  does not  by itself cause  the resulting  --
-- executable to be covered by the GNU General Public License. This  --
-- exception does not however invalidate any other reasons why the   --
-- executable file  might be covered by the  GNU Public License.     --
-----------------------------------------------------------------------


with A4A.Library.Timers.TON; use A4A.Library.Timers;
with A4A.Library.Devices.Contactor; use A4A.Library.Devices;
package A4A.Application is

   -- IO Areas
   type Inputs_Type is array (1 .. 10) of Integer;
   type Outputs_Type is array (1 .. 10) of Integer;

   MyInputs  : Inputs_Type  := (others => 0);
   MyOutputs : Outputs_Type := (others => 0);

   -- User Objects creation

   Ack_Faults       : Boolean := False;
   -- Faults Acknowledgement

   Tempo_TON_1      : TON.Instance;
   -- My Tempo TON 1

   MyPump13FeedBack : Boolean := False;
   MyPump13Cmd_On   : Boolean := False;
   MyPump13Coil     : Boolean := False;
   MyPump13IsOn     : Boolean := False;
   MyPump13         : Contactor.Instance := Contactor.Create ("Pump13");

   -- User Program
   procedure Main_Cyclic;
   procedure Periodic_Run_1;

end A4A.Application;
