
-----------------------------------------------------------------------
--                       Ada for Automation                          --
--                                                                   --
--                 Copyright (C) 2012, Stephane LOS                  --
--                                                                   --
-- This library is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public               --
-- License as published by the Free Software Foundation; either      --
-- version 2 of the License, or (at your option) any later version.  --
--                                                                   --
-- This library is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of    --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU --
-- General Public License for more details.                          --
--                                                                   --
-- You should have received a copy of the GNU General Public         --
-- License along with this library; if not, write to the             --
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,      --
-- Boston, MA 02111-1307, USA.                                       --
--                                                                   --
-- As a special exception, if other files instantiate generics from  --
-- this unit, or you link this unit with other files to produce an   --
-- executable, this  unit  does not  by itself cause  the resulting  --
-- executable to be covered by the GNU General Public License. This  --
-- exception does not however invalidate any other reasons why the   --
-- executable file  might be covered by the  GNU Public License.     --
-----------------------------------------------------------------------


package body A4A.Generic_Dual_Port_Memory is

   protected body Dual_Port_Memory is
      procedure Inputs_Write  (Inputs : in Inputs_Type) is
      begin
         Flag_New_Inputs := True;
         DataIn := Inputs;
      end Inputs_Write;

      procedure Outputs_Write (Outputs : in Outputs_Type) is
      begin
         Flag_New_Outputs := True;
         DataOut := Outputs;
      end Outputs_Write;

      procedure Get_Inputs (Inputs : out Inputs_Type) is
      begin
         Flag_New_Inputs := False;
         Inputs := DataIn;
      end Get_Inputs;

      procedure Get_Outputs (Outputs : out Outputs_Type) is
      begin
         Flag_New_Outputs := False;
         Outputs := DataOut;
      end Get_Outputs;

      function New_Inputs return Boolean is
      begin
         return Flag_New_Inputs;
      end New_Inputs;

      function New_Outputs return Boolean is
      begin
         return Flag_New_Outputs;
      end New_Outputs;

   end Dual_Port_Memory;

end A4A.Generic_Dual_Port_Memory;
