
-----------------------------------------------------------------------
--                       Ada for Automation                          --
--                                                                   --
--                 Copyright (C) 2012, Stephane LOS                  --
--                                                                   --
-- This library is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public               --
-- License as published by the Free Software Foundation; either      --
-- version 2 of the License, or (at your option) any later version.  --
--                                                                   --
-- This library is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of    --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU --
-- General Public License for more details.                          --
--                                                                   --
-- You should have received a copy of the GNU General Public         --
-- License along with this library; if not, write to the             --
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,      --
-- Boston, MA 02111-1307, USA.                                       --
--                                                                   --
-- As a special exception, if other files instantiate generics from  --
-- this unit, or you link this unit with other files to produce an   --
-- executable, this  unit  does not  by itself cause  the resulting  --
-- executable to be covered by the GNU General Public License. This  --
-- exception does not however invalidate any other reasons why the   --
-- executable file  might be covered by the  GNU Public License.     --
-----------------------------------------------------------------------


generic
   type Inputs_Type is private;
   type Outputs_Type is private;

package A4A.Generic_Dual_Port_Memory is

   protected type Dual_Port_Memory is
      procedure Inputs_Write (Inputs : in Inputs_Type);
      procedure Outputs_Write (Outputs : in Outputs_Type);
      procedure Get_Inputs (Inputs : out Inputs_Type);
      procedure Get_Outputs (Outputs : out Outputs_Type);
      function New_Inputs return Boolean;
      function New_Outputs return Boolean;
   private
      DataIn : Inputs_Type;
      DataOut : Outputs_Type;
      Flag_New_Inputs : Boolean;
      Flag_New_Outputs : Boolean;
   end Dual_Port_Memory;

end A4A.Generic_Dual_Port_Memory;
