
-----------------------------------------------------------------------
--                       Ada for Automation                          --
--                                                                   --
--                 Copyright (C) 2012, Stephane LOS                  --
--                                                                   --
-- This library is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public               --
-- License as published by the Free Software Foundation; either      --
-- version 2 of the License, or (at your option) any later version.  --
--                                                                   --
-- This library is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of    --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU --
-- General Public License for more details.                          --
--                                                                   --
-- You should have received a copy of the GNU General Public         --
-- License along with this library; if not, write to the             --
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,      --
-- Boston, MA 02111-1307, USA.                                       --
--                                                                   --
-- As a special exception, if other files instantiate generics from  --
-- this unit, or you link this unit with other files to produce an   --
-- executable, this  unit  does not  by itself cause  the resulting  --
-- executable to be covered by the GNU General Public License. This  --
-- exception does not however invalidate any other reasons why the   --
-- executable file  might be covered by the  GNU Public License.     --
-----------------------------------------------------------------------


with A4A.Library.Timers.TON; use A4A.Library.Timers;
package A4A.Library.Devices.Contactor is

   type Instance is new Device_Type with private;

   overriding function Create (
                               Id : in String
                              )
                               return Instance;
   procedure Cyclic (
                     Device    : in out Instance;
                     Feed_Back : in Boolean;
                     Ack       : in Boolean;
                     Cmd_On    : in Boolean;
                     Coil      : out Boolean
                    );

   function is_On (
                   Device    : in Instance
                  ) return Boolean;

private
   type Device_Status is (
                          Status_Off,
                          Status_Going_On,
                          Status_On,
                          Status_Going_Off,
                          Status_Fault
                         );

   type Instance is new Device_Type with
      record
         Status    : Device_Status;
         Tempo_Dis : TON.Instance;
      end record;

end A4A.Library.Devices.Contactor;
