
-----------------------------------------------------------------------
--                       Ada for Automation                          --
--                                                                   --
--                 Copyright (C) 2012, Stephane LOS                  --
--                                                                   --
-- This library is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public               --
-- License as published by the Free Software Foundation; either      --
-- version 2 of the License, or (at your option) any later version.  --
--                                                                   --
-- This library is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of    --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU --
-- General Public License for more details.                          --
--                                                                   --
-- You should have received a copy of the GNU General Public         --
-- License along with this library; if not, write to the             --
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,      --
-- Boston, MA 02111-1307, USA.                                       --
--                                                                   --
-- As a special exception, if other files instantiate generics from  --
-- this unit, or you link this unit with other files to produce an   --
-- executable, this  unit  does not  by itself cause  the resulting  --
-- executable to be covered by the GNU General Public License. This  --
-- exception does not however invalidate any other reasons why the   --
-- executable file  might be covered by the  GNU Public License.     --
-----------------------------------------------------------------------


with Ada.Real_Time; use Ada.Real_Time;
package body A4A.Library.Timers.TON is

   procedure Cyclic (
                     This_Timer : in out Instance;
                     Start      : in Boolean;
                     Preset     : in Time_Span;
                     Elapsed    : out Time_Span;
                     Q          : out Boolean
                    ) is
   begin
      if Start then
         if not This_Timer.Running then
            This_Timer.Running := True;
            This_Timer.Start_Time := Clock;
            This_Timer.End_Time := This_Timer.Start_Time + Preset;
            Elapsed := Time_Span_Zero;
         end if;
      else
         if This_Timer.Running then
            This_Timer.Running := False;
         end if;
      end if;

      if This_Timer.Running then
         Elapsed := Clock - This_Timer.Start_Time;
      end if;
      Q := Elapsed >= Preset;
   end Cyclic;

end A4A.Library.Timers.TON;
