
-----------------------------------------------------------------------
--                       Ada for Automation                          --
--                                                                   --
--                 Copyright (C) 2012, Stephane LOS                  --
--                                                                   --
-- This library is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public               --
-- License as published by the Free Software Foundation; either      --
-- version 2 of the License, or (at your option) any later version.  --
--                                                                   --
-- This library is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of    --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU --
-- General Public License for more details.                          --
--                                                                   --
-- You should have received a copy of the GNU General Public         --
-- License along with this library; if not, write to the             --
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,      --
-- Boston, MA 02111-1307, USA.                                       --
--                                                                   --
-- As a special exception, if other files instantiate generics from  --
-- this unit, or you link this unit with other files to produce an   --
-- executable, this  unit  does not  by itself cause  the resulting  --
-- executable to be covered by the GNU General Public License. This  --
-- exception does not however invalidate any other reasons why the   --
-- executable file  might be covered by the  GNU Public License.     --
-----------------------------------------------------------------------


with Ada.Command_Line;
with Ada.Text_IO;
with Ada.Characters.Latin_1;

with A4A.Generic_Periodic_Task;
with A4A.Kernel;

procedure a4a_console_main is
   Periodic_Task_1 : A4A.Kernel.Periodic_Task (Period => 100);
   Generic_Periodic_Task_1 : A4A.Kernel.P1.Periodic_Task (Task_Priority => 10,
                                                          Period_In_Milliseconds => 1000);

begin

   -- Let's print our Command Line
   Ada.Text_IO.Put("a4a_console_main started as : ");
   Ada.Text_IO.Put(Ada.Command_Line.Command_Name & " ");
   for Index in 1 .. Ada.Command_Line.Argument_Count loop
      Ada.Text_IO.Put(Ada.Command_Line.Argument(Index) & " ");
   end loop;
   Ada.Text_IO.New_Line;

   Ada.Text_IO.Put_Line ("a4a_console_main finished !");
end a4a_console_main;
