
-----------------------------------------------------------------------
--                       Ada for Automation                          --
--                                                                   --
--                 Copyright (C) 2012, Stephane LOS                  --
--                                                                   --
-- This library is free software; you can redistribute it and/or     --
-- modify it under the terms of the GNU General Public               --
-- License as published by the Free Software Foundation; either      --
-- version 2 of the License, or (at your option) any later version.  --
--                                                                   --
-- This library is distributed in the hope that it will be useful,   --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of    --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU --
-- General Public License for more details.                          --
--                                                                   --
-- You should have received a copy of the GNU General Public         --
-- License along with this library; if not, write to the             --
-- Free Software Foundation, Inc., 59 Temple Place - Suite 330,      --
-- Boston, MA 02111-1307, USA.                                       --
--                                                                   --
-- As a special exception, if other files instantiate generics from  --
-- this unit, or you link this unit with other files to produce an   --
-- executable, this  unit  does not  by itself cause  the resulting  --
-- executable to be covered by the GNU General Public License. This  --
-- exception does not however invalidate any other reasons why the   --
-- executable file  might be covered by the  GNU Public License.     --
-----------------------------------------------------------------------


with Ada.Text_IO;
with Ada.Integer_Text_IO;
with Ada.Long_Integer_Text_IO;

with A4A; use A4A;

procedure Test_Shift is
   MyDWord  : A4A.DWord;
   MyDWord1 : A4A.DWord;
   MyDWord2 : A4A.DWord;
   --MyWord : A4A.Word;
   --MyByte : A4A.Byte;
begin
   MyDWord := 16#12345678#;
   Ada.Text_IO.Put (Item => "MyDWord : ");
   Ada.Long_Integer_Text_IO.Put (Item => Long_Integer(MyDWord), Base => 16);
   Ada.Text_IO.New_Line(2);

   Ada.Text_IO.Put_Line (Item => " -- " & "SHL (Value => MyDWord, Amount => 4);");
   MyDWord := A4A.SHL (Value => MyDWord, Amount => 4);
--     MyDWord := A4A.Shift_Left (Value => MyDWord, Amount => 4);

   Ada.Text_IO.Put (Item => "MyDWord : ");
   Ada.Long_Integer_Text_IO.Put (Item => Long_Integer(MyDWord), Base => 16);
   Ada.Text_IO.New_Line(2);

   Ada.Text_IO.Put_Line (Item => " -- " & "ROL (Value => MyDWord, Amount => 4);");
   MyDWord := A4A.ROL (Value => MyDWord, Amount => 4);
--     MyDWord := A4A.Rotate_Left (Value => MyDWord, Amount => 4);

   Ada.Text_IO.Put (Item => "MyDWord : ");
   Ada.Long_Integer_Text_IO.Put (Item => Long_Integer(MyDWord), Base => 16);
   Ada.Text_IO.New_Line(2);

   MyDWord1 := 16#0000ffff#;
   Ada.Text_IO.Put (Item => "MyDWord1 : ");
   Ada.Long_Integer_Text_IO.Put (Item => Long_Integer(MyDWord1), Base => 16);
   Ada.Text_IO.New_Line(2);

   MyDWord2 := 16#ffff0000#;
   Ada.Text_IO.Put (Item => "MyDWord2 : ");
   Ada.Long_Integer_Text_IO.Put (Item => Long_Integer(MyDWord2), Base => 16);
   Ada.Text_IO.New_Line(2);

   Ada.Text_IO.Put_Line (Item => " -- " & "MyDWord := MyDWord1 and MyDWord2;");
   MyDWord := MyDWord1 and MyDWord2;

   Ada.Text_IO.Put (Item => "MyDWord : ");
   Ada.Long_Integer_Text_IO.Put (Item => Long_Integer(MyDWord), Base => 16);
   Ada.Text_IO.New_Line(2);

   Ada.Text_IO.Put_Line (Item => " -- " & "MyDWord := MyDWord1 or MyDWord2;");
   MyDWord := MyDWord1 or MyDWord2;

   Ada.Text_IO.Put (Item => "MyDWord : ");
   Ada.Long_Integer_Text_IO.Put (Item => Long_Integer(MyDWord), Base => 16);
   Ada.Text_IO.New_Line(2);

   Ada.Text_IO.Put_Line (Item => " -- " & "MyDWord := MyDWord1 xor MyDWord2;");
   MyDWord := MyDWord1 xor MyDWord2;

   Ada.Text_IO.Put (Item => "MyDWord : ");
   Ada.Long_Integer_Text_IO.Put (Item => Long_Integer(MyDWord), Base => 16);
   Ada.Text_IO.New_Line(2);

   Ada.Text_IO.Put_Line (Item => " -- " & "MyDWord := not MyDWord;");
   MyDWord := not MyDWord;

   Ada.Text_IO.Put (Item => "MyDWord : ");
   Ada.Long_Integer_Text_IO.Put (Item => Long_Integer(MyDWord), Base => 16);
   Ada.Text_IO.New_Line(2);

   Ada.Text_IO.Put_Line (Item => " -- " & "MyDWord := not MyDWord;");
   MyDWord := not MyDWord;

   Ada.Text_IO.Put (Item => "MyDWord : ");
   Ada.Long_Integer_Text_IO.Put (Item => Long_Integer(MyDWord), Base => 16);
   Ada.Text_IO.New_Line(2);

end Test_Shift;
